
function highResImOutput = InterpolationMF( lowResIm , scale , methodInter );

    if nargin == 1
        methodInter = 2;
    end
    
    kernelLen   = 1.5;
    [ heightL widthL ]  = size( lowResIm );

    lowResImInput       = double( lowResIm );
    highResImBicubic    = imresize( lowResImInput , scale , 'bicubic' );

    [mfX mfY gxx gyy]   = GetMovingField_TIP( highResImBicubic , kernelLen , scale );
    
    switch methodInter
        case 1
            highResImOutput     = mirt2D_mexinterp( highResImBicubic , mfX , mfY );
            [ h w ]             = size( highResImOutput );
            highResImOutput( 1:scale     , : ) = highResImBicubic( 1:scale     , : ) ;
            highResImOutput( h-scale+1:h , : ) = highResImBicubic( h-scale+1:h , : );
            highResImOutput( : , 1:scale     ) = highResImBicubic( : , 1:scale     );
            highResImOutput( : , w-scale+1:w ) = highResImBicubic( : , w-scale+1:w );
        case 2
            %%%%    here, we do not consider the case on the margin
            highResImOutput     = highResImBicubic;
            [height width]      = size( highResImOutput );
            mfXLow              = mfX / scale + 0.5;
            mfYLow              = mfY / scale + 0.5;
            for dh = floor(scale+1) : floor(height-scale)
                for dw = floor(scale+1) : floor(width-scale)
                    lowPosH = mfYLow(dh,dw);    lowPosH = max(1,min(heightL-1,lowPosH));
                    lowPosW = mfXLow(dh,dw);    lowPosW = max(1,min(widthL-1,lowPosW));
                    lowPosHU= floor( lowPosH ); lowPosHD = lowPosHU + 1;
                    lowPosWL= floor( lowPosW ); lowPosWR = lowPosWL + 1;
                    pixelUL = lowResIm( lowPosHU , lowPosWL );
                    pixelUR = lowResIm( lowPosHU , lowPosWR );
                    pixelDL = lowResIm( lowPosHD , lowPosWL );
                    pixelDR = lowResIm( lowPosHD , lowPosWR );
                    distU   = lowPosH - lowPosHU;   distD   = lowPosHD - lowPosH;
                    distL   = lowPosW - lowPosWL;   distR   = lowPosWR - lowPosW;
                    pixelU  = pixelUL*distR+pixelUR*distL;
                    pixelD  = pixelDL*distR+pixelDR*distL;
                    highResImOutput(dh,dw) = pixelU*distD+pixelD*distU;
                end
            end
        otherwise
    end

end

